import numpy as np
import scipy.optimize as opt
import matplotlib.pyplot as plt
def sigmoid(X):
    '''sigmoid function '''
    return 1/(1+np.exp(-X))

def cost(theta, X, y):
    '''  logistic regression cost    '''
    sxt = sigmoid(np.dot(X, theta));
    mcost = (-y)*np.log(sxt) - (1-y)*np.log(1-sxt)
    return mcost.mean()  
#def gradient(theta, X, y):
#    '''  logistic regression gradient    '''
#    sxt = sigmoid(np.dot(X, theta))
#    #label and prediction difference
#    err = sxt - y 
#    grad = np.dot(err, sxt) / y.size # gradient vector
#    return grad
#load the dataset
def predict(theta, X):
    #test new data
    m, n = X.shape
    p = np.zeros(shape=(m, 1));
    h = sigmoid(X.dot(theta.T));
    p = 1*(h>=0.5);
    return p      


puredata = np.loadtxt('iris1.csv', delimiter=',');
#separate attributes x from class labels
X = puredata[:,0:2];
Y = puredata[:,2];
#append "1's" to attributes first column
XX = np.append( np.ones((X.shape[0], 1)), X, axis=1);
m , n = XX.shape;
#create initial theta values
theta = 0.1* np.random.randn(n);
#use fmin_bfgs optimisation function find thetas
theta = opt.fmin_bfgs(cost, theta, args=(XX, Y));
#plot data
versicolor = np.where(Y == 1);
virginica = np.where(Y == 0);
fig = plt.figure('training data');
plt.scatter(XX[versicolor, 1], XX[versicolor, 2], marker='o', c='b');
plt.scatter(XX[virginica, 1], XX[virginica, 2], marker='x', c='r');
plt.xlabel('petallength');
plt.ylabel('petalwidth');
plt.legend(['Iris-versicolor', 'Iris-virginica']);
#plot decision boundary
plot_x = np.array([min(XX[:, 1]), max(XX[:, 1])]);
plot_y = (- 1.0 / theta[2]) * (theta[1] * plot_x + theta[0]);
plt.plot(plot_x, plot_y);
plt.show();
#test classifier with some random data
XXX = np.array([[1.0, 5.0, 1.4], #0
                [1.0, 1.4, 2.0], #0
                [1.0, 7.0, 1.0]]); #1
print(predict(theta, XXX)); 
#test on labeled data
p = predict(theta, XX);                
print ('Accuracy: %f' % ((Y[np.where(p == Y)].size / float(Y.size)) * 100.0));